#!/bin/bash

mkdir results/

cd weighted
mkdir build
cd build
cmake ..
make
../getdata.sh
../getdata2.sh
../make_weighted_graphs.sh
../perform_tests.sh 100
cd ../..
mv weighted/build/results.txt results/weighted_results.txt

cd unweighted
cd older
mkdir build
cd build
cmake ../
make
cd ../..
cp older/build/snap_to_dimacs .

# Create download files 
cd scripts
./getdata.sh
./getdata2.sh
cd ../

# compile
mkdir build
cd build
cmake ../
make

cd ../  # back to working direcotry

# run kernelization and Blossom5
ulimit -s unlimited
cd scripts
./run_all.py -t 3600 -n 100 -o ../../results/results.txt
# ./run_all.py -t 300 -n 3 -o results/blossom5_results.txt

# run python implementation
./run_all_mv_faster.py --output ../../results/mv_results.txt

# run c implementation
cd ../c_impl
make
./run_all_c.py --output ../../results/c_results.txt
