#include <stdio.h>
#include <time.h>
#include "graph.h"
#include "matching.h"

typedef ListCell Cell;

#define THOUSAND 1000
#define MILLION  1000000

Void main ()
{
   int   N;
   List *M;
   Cell *P;
   
   Graph  *G;
   Vertex *V;
   Edge   *E;
   
   struct timespec start, end;
   
   G = ReadGraph(stdin);

   clock_gettime(CLOCK_MONOTONIC, &start); 
   M = MaximumCardinalityMatching(G);
   clock_gettime(CLOCK_MONOTONIC, &end); 
   
   int delta_sec = end.tv_sec - start.tv_sec;
   long delta_nsec = end.tv_nsec - start.tv_nsec;
   printf("c_time: %ld\n", THOUSAND * (long) delta_sec + delta_nsec / MILLION);

   fprintf(stdout, "c_matchings: %d\n", ListSize(M));
 
   N = 1;
   ForAllGraphVertices(V, G, P)
      VertexRelabel(V, (VertexData) N++);
   ForAllEdges(E, M, P)
      // fprintf(stdout, "(%d, %d)\n", (int) VertexLabel(EdgeFrom(E)), (int) VertexLabel(EdgeTo(E)));
   DestroyList(M);
   
   DestroyGraph(G);
}
