#!/usr/bin/env python3
from argparse import ArgumentParser

import numpy as np
from scipy.spatial import Delaunay
import networkx as nx

from serialize import serialize

X = 2 ** 20


if __name__ == '__main__':
    parser = ArgumentParser()
    parser.add_argument('n', type=int)
    parser.add_argument('--file', type=str)
    args = parser.parse_args()

    n, file = args.n, args.file
    points = np.random.rand(n, 2)
    triangles = Delaunay(points)
    g = nx.Graph()
    for t in triangles.simplices:
        g.add_edge(t[1], t[2])
        g.add_edge(t[2], t[0])
        g.add_edge(t[0], t[1])
    serialize(g, file=file)
