#!/usr/bin/env python3
from argparse import ArgumentParser

import numpy as np
from scipy.spatial import Delaunay
import networkx as nx

from serialize import serialize


if __name__ == '__main__':
    parser = ArgumentParser()
    parser.add_argument('n', type=int)
    parser.add_argument('--file', type=str)
    args = parser.parse_args()

    n, file = args.n, args.file
    assert n % 3 == 0, 'The size of graph must be a multiple of 3.'
    g = nx.Graph()
    for i in range(n // 3):
        g.add_edge(3 * i, 3 * i + 1)
        g.add_edge(3 * i, 3 * i + 2)
        g.add_edge(3 * i + 1, 3 * i + 2)
    rs = np.random.randint(3, size=(n - 1, 2))
    for i in range(n - 1):
        g.add_edge(3 * i + rs[i][0], 3 * i + 3 + rs[i][1])
    serialize(g, file=file)
