#!/usr/bin/env python3
from argparse import ArgumentParser

import numpy as np
from scipy.spatial import Delaunay
import networkx as nx

from serialize import serialize


if __name__ == '__main__':
    parser = ArgumentParser()
    parser.add_argument('n', type=int)
    parser.add_argument('--file', type=str)
    args = parser.parse_args()

    n, file = args.n, args.file
    assert n % 3 == 0, 'The size of graph must be a multiple of 3.'
    g = nx.Graph()
    for i in range(n // 3):
        g.add_edge(3 * i, 3 * i + 1)
        g.add_edge(3 * i, 3 * i + 2)
        g.add_edge(3 * i + 1, 3 * i + 2)
    for i in range(n // 3 - 1):
        p = np.random.permutation(3)
        for j, q in enumerate(p):
            g.add_edge(3 * i + j, 3 * i + 3 + q)
    serialize(g, file=file)
