cmake_minimum_required(VERSION 2.8.3 FATAL_ERROR)
include(ExternalProject)

macro(install_boost boost_toolset boost_libs)
ExternalProject_Add(boost
	URL http://sourceforge.net/projects/boost/files/boost/1.60.0/boost_1_60_0.tar.gz/download
	#URL_MD5 0e3f6ff3c12050980f297360deabe0ac
	CONFIGURE_COMMAND CC=${CMAKE_C_COMPILER} CXX=${CMAKE_CXX_COMPILER}  ./bootstrap.sh --with-toolset=${boost_toolset} --prefix=${CMAKE_CURRENT_BINARY_DIR}/boost --with-libraries=${boost_libs}
	BUILD_COMMAND ./b2  variant=release link=static runtime-link=static threading=multi cxxflags=${CMAKE_CXX_FLAGS}
	INSTALL_COMMAND ./b2 variant=release link=static runtime-link=static threading=multi cxxflags=${CMAKE_CXX_FLAGS} install 	
	BUILD_IN_SOURCE 1
)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/boost/include)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/boost/lib)
endmacro(install_boost)


macro(install_libtorrent)
ExternalProject_Add(libtorrent
	URL https://github.com/arvidn/libtorrent/releases/download/libtorrent-1_0_7/libtorrent-rasterbar-1.0.7.tar.gz
	#URL_MD5 0e3f6ff3c12050980f297360deabe0ac
	CONFIGURE_COMMAND OPENSSL_INCLUDE_DIR=${CMAKE_BINARY_DIR}/openssl/include OPENSSL_LIBRARIES=${CMAKE_BINARY_DIR}/openssl/lib CC=${CMAKE_C_COMPILER}  CXX=${CMAKE_CXX_COMPILER}  ./configure --prefix=${CMAKE_CURRENT_BINARY_DIR}/libtorrent --with-boost=${CMAKE_CURRENT_BINARY_DIR}/boost --with-openssl=${CMAKE_CURRENT_BINARY_DIR}/openssl --disable-shared --disable-dht --enable-static 
	BUILD_COMMAND make CXXFLAGS=${CMAKE_CXX_FLAGS} 
	INSTALL_COMMAND make install
	DEPENDS boost 
	DEPENDS openssl 
	BUILD_IN_SOURCE 1
)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/libtorrent/include)

link_directories(${CMAKE_CURRENT_BINARY_DIR}/libtorrent/lib)
endmacro(install_libtorrent)


macro(install_openssl)
EXTERNALPROJECT_ADD(openssl
	URL http://www.openssl.org/source/openssl-1.0.2-latest.tar.gz
	CONFIGURE_COMMAND CC=${CMAKE_C_COMPILER} CXX=${CMAKE_CXX_COMPILER} ./configure darwin64-x86_64-cc no-shared no-idea no-mdc2 no-rc5 --prefix=${CMAKE_BINARY_DIR}/openssl 
	BUILD_COMMAND make depend && make
	INSTALL_COMMAND make install_sw
	BUILD_IN_SOURCE 1
)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/openssl/include)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/openssl/lib)
endmacro(install_openssl)





