#include "kernelizer.hpp"
#include "blossom5.hpp"
#include <cassert>

int main() {

  std::mt19937 rng;
  rng.seed(std::random_device()());
  std::uniform_int_distribution<std::mt19937::result_type> dist(1, 100);

  for (int i = 1; i <= 500; i += 5) {
    for (int j = 1; j < 100; ++j) {
      auto g = graph::generate_graph(i, dist(rng));
      int mm_size = mmatching::blossom5::maximum_matching_size(g.edgeset().begin(),g.edgeset().end(),g.N(),g.edgeset().M());
      kernelizer::kernelizer k(g);
      int mm_kernel = k.kernelize();
      int mm_size_kernel = mmatching::blossom5::maximum_matching_size(g.edgeset().begin(),g.edgeset().end(),g.N(),g.edgeset().M());
      assert(mm_size == mm_kernel + mm_size_kernel);
    }
  }

  printf("No error has been detected\n");
}
