from argparse import ArgumentParser
import networkx as nx
from collections import defaultdict


from mv_algorithm_fast_test import mv_max_cardinality

if __name__ == '__main__':
    parser = ArgumentParser()
    parser.add_argument('--file')
    args = parser.parse_args()

    edges = []
    with open(args.file, 'r') as f:
        for line in f:
            identifier, u, v = line.split()
            if identifier is 'e':
                edges.append((int(u), int(v)))
    G = nx.Graph()
    G.add_edges_from(edges)
    n_matchings, matchings, time = mv_max_cardinality(G, 1, False, 100)
    counter = defaultdict(int)
    for u, v in matchings.items():
        counter[u] += 1
        counter[v] += 1
    for v, count in counter.items():
        if count > 2:
            print(v, 'matched to', matchings[v])
