#Maximum Matching

This contains the source code for the experiments of *Data Reductions for Maximum Matching on Real-World Graphs*.

## Building and Testing

We are going to build this CMake project in the subdirectory ```build```.

```
mkdir build
cmake ..
make
```

In order to run the unit tests it is important that the build directory is a sub directory of the source directory, otherwise some test will fail because they will be unable to find some test graphs.
You can run the unit tests with the following command. 

```
make check
```
All tests shall pass!

## Getting the Data Set

The scripts ```getdata.sh``` and ```getdata2.sh``` are downloading the graphs from the [SNAP Data Set](https://snap.stanford.edu/data/index.html), converting them to the [DIMACS Graph Format](http://prolland.free.fr/works/research/dsat/dimacs.html).
After executing these scripts, you find the data set in the ```data``` directory. 
Please run these scripts form the build directory.

```
../getdata.sh
../getdata2.sh
```
### Weighted Data Set
So far we only have unweighted graphs.
The script ```make_weighted_graphs.sh``` reads all graphs in ```data``` directory and puts a weight on each edge. The weights are between 1 and 1000 and chosen independently and uniformly at random.
After executing this script, you find the weighted data set in the ```dataw``` directory. 
Please run this scripts form the build directory.

```
../make_weighted_graphs.sh
```
## Running the Experiments
Now we are all set to run the experiments. 
The script ```../perform_tests.sh X``` runs the test program on each graph of the data set ```X``` times.
Hence, to run the test program on each graph 100 times, we execute the following.

```  
../perform_tests.sh 100
```
The results are written to ```results.txt```.
