#pragma once
#include <vector>
#include <deque>
template <class OS, class Iter> OS &print(OS &os, Iter begin, Iter end) {

	os << "{";
	auto iter = begin;
	if (iter != end) {
		--end;
		while (iter != end) {
			os << *iter << ", ";
			iter++;
		}
		os << *iter;
	}
	os << "}";
	return os;
}
template <class OS, class T> OS &operator<<(OS &os, const std::vector<T> &vec) {
	return print(os,vec.begin(), vec.end());
}
template <class OS, class T> OS &operator<<(OS &os, const std::deque<T> &vec) {
	return print(os,vec.begin(), vec.end());
}

template <class Iter> struct range {

	range(std::pair<Iter, Iter> p) : first(p.first), last(p.second) {}

	Iter begin() { return first; }
	Iter end() { return last; }

      private:
	Iter first, last;
};
template <class Iter> range<Iter> to_range(const std::pair<Iter, Iter> &p) { return range<Iter>(p); }
